//
//  DateRangePickerViewController.h
//  DUREX Vendor Control
//
//  Created by Imanol Barba on 9/13/14.
//  Copyright (c) 2014 Emmoco. All rights reserved.
//

//
//  DatePickerViewController.h
//  DUREX Vendor Control
//
//  Created by Imanol Barba on 03/09/14.
//  Copyright (c) 2014 Emmoco. All rights reserved.
//

@class DateRangePickerViewController;

#import <UIKit/UIKit.h>
#import <QuartzCore/QuartzCore.h>
#import "DUREXAppDelegate.h" 
#import "ChildViewController.h"

@protocol DateRangePickerViewControllerDelegate <NSObject>
- (void)passDateRangeViewController:(DateRangePickerViewController*)controller didFinishEnteringItem:(NSDate*) from : (NSDate*) to;

@end

@interface DateRangePickerViewController : ChildViewController

@property (strong, nonatomic) IBOutlet UIView *dateRangePickerView;
@property (strong, nonatomic) IBOutlet UIDatePicker *fromDate;
@property (strong, nonatomic) IBOutlet UIDatePicker *toDate;
@property (strong, nonatomic) IBOutlet UISwitch *fromToggler;
@property (strong, nonatomic) IBOutlet UISwitch *toToggler;
@property (strong, nonatomic) IBOutlet UIButton *doneButton;
@property (strong, nonatomic) IBOutlet UILabel *toLabel;
@property (strong, nonatomic) IBOutlet UIScrollView *scrollView;
@property (strong, nonatomic) IBOutlet UIView *scrolledView;
@property (nonatomic, strong) id <DateRangePickerViewControllerDelegate> delegate;

- (void)showInView:(UIView *)aView animated:(BOOL)animated;
- (IBAction)toggleFromDate:(id)sender;
- (IBAction)toggleToDate:(id)sender;
- (IBAction)closePopup:(id)sender;

@end
