//
//  MenuTableViewController.h
//  DUREX Vendor Control
//
//  Created by Imanol Barba on 5/23/14.
//  Copyright (c) 2014 Emmoco. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "CommunicationProtocol.h"
#import "Stack.h"
#import "DatePickerViewController.h"
#import "PriceChangerViewController.h"

#define num(x) [NSNumber numberWithUnsignedInt:x]

#define MENU_ELEMENTS                   @"Maintenance",@"Basic Configuration",@"Sending a Report"
#define MENU_CELLS_PER_SECTION          num(3)
#define MENU_HEADERS                        nil

#define MAINTENANCE_ELEMENTS            @"CH1 presence",@"CH2 presence",@"CH3 presence",@"CH4 presence",@"CH5 presence",@"CH6 presence",@"CH7 presence",@"CH8 presence",@"CH1 spin",@"CH2 spin",@"CH3 spin",@"CH4 spin",@"CH5 spin",@"CH6 spin",@"CH7 spin",@"CH8 spin",@"Door sensor",@"Wall sensor",@"Oscillator",@"1€ Coin presence",@"50c Coin presence",@"1€ Coin spin",@"50c Coin spin",@"Sales log",@"Incident report",@"Send report"
#define MAINTENANCE_CELLS_PER_SECTION   num(23),num(3)
#define MAINTENANCE_HEADERS              NSLocalizedString(@"Sensors", nil),NSLocalizedString(@"Commands", nil)

#define SALES_ELEMENTS            @"20€ Notes",@"10€ Notes",@"5€ Notes",@"2€ Coins",@"1€ Coins",@"50c Coins",@"Channel",@"Product Code",@"Nominal Price",@"Discounted Price",@"1€ Change",@"50c Change",@"20€ Notes",@"10€ Notes",@"5€ Notes",@"2€ Coins",@"1€ Coins",@"50c Coins",@"Channel",@"Product Code",@"Nominal Price",@"Discounted Price",@"1€ Change",@"50c Change",@"20€ Notes",@"10€ Notes",@"5€ Notes",@"2€ Coins",@"1€ Coins",@"50c Coins",@"Channel",@"Product Code",@"Nominal Price",@"Discounted Price",@"1€ Change",@"50c Change"
#define SALES_CELLS_PER_SECTION   num(12),num(12),num(12)
#define SALES_HEADERS             @"14/06/2014",@"25/06/2014",@"05/07/2014"

#define CONFIGURATION_ELEMENTS          @"Update Date & Time",@"Update product price",@"Update product name"
#define CONFIGURATION_CELLS_PER_SECTION num(3)
#define CONFIGURATION_HEADERS           nil


#define CELL_IDENTIFIERS                @"MenuCell",@"MaintenanceCell",@"SalesCell",@"ConfigCell",@"ReportCell"

enum {
    MENU = 0,
    MAINTENANCE,
    SALES,
    BASIC_CONFIGURATION,
    REPORT,
} navigationLevel;

@interface MenuTableViewController : UITableViewController <DatePickerViewControllerDelegate,PriceChangerViewControllerDelegate>

@property (strong,nonatomic) Stack *parentLayout;
@property (strong,nonatomic) DatePickerViewController *datePickerViewController;
@property (strong,nonatomic) PriceChangerViewController *priceChangerViewController;

- (void) navBack;

@end
