//
//  EMAppDelegate.m
//  Indicator Example
//
//  Created by Dexter Weiss on 10/15/13.
//  Copyright (c) 2013 Emmoco. All rights reserved.
//

#import "EMAppDelegate.h"
#import "EMFramework.h"
#import "EMDevicePickerViewController.h"

@implementation EMAppDelegate

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    UINavigationController *navController = (UINavigationController *)[[self window] rootViewController];
    [self setNavController:navController];
    [[self navController] setDelegate:self];
    
    [[EMConnectionListManager sharedManager] startUpdating];
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    [[EMConnectionListManager sharedManager] startUpdating];
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

#pragma mark - Navigation Controller

- (void)navigationController:(UINavigationController *)navigationController didShowViewController:(UIViewController *)viewController animated:(BOOL)animated {
    if ([viewController isKindOfClass:[EMDevicePickerViewController class]]) {
        [[EMConnectionManager sharedManager] disconnectWithSuccess:^{
            
        } onFail:^(NSError *error) {
            
        }];
    }
}

@end
